<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

buffer::str('<h2>'.__('Comments Antispam').'</h2>');

$file = DC_BASE_DIR . '/conf/questions.ini';
$url = 'tools.php?p=antispam';

if (!defined('dc_use_custom_questions') || !dc_use_custom_questions)
{
	$err = __("You have to enable 'Use custom antispam questions' in the blog configuration to edit this page.");
	buffer::str('<div class="erreur"><p><strong>'.__('Error(s)').' :</strong></p><p>'.$err.'</p></div>');
}
elseif (file_exists($file) && !is_writable($file))
{
	$err = '<p>'.sprintf(__('Config file %s, is not writable.'),'<strong>conf/questions.ini</strong>').'</p>';
	buffer::str('<div class="erreur"><p><strong>'.__('Error(s)').' :</strong></p>'.$err.'</div>');
}
else
{
	if (!empty($_POST['save']))
	{
		$ini = '';
		$i = 0;

		foreach ($_POST['questions'] as $q)
		{
			if (empty($q[0]))
			{
				continue;
			}

			$ini .= '[' . (int)$i . "]\n";
			$ini .= '0 = "' . $q[0] . "\"\n";
			$ini .= '1 = "' . $q[1] . "\"\n\n";
			$i++;
		}

		$fp = @fopen($file, 'w');
		if ($fp)
		{
			fputs($fp, $ini);
			fclose($fp);

			header('Location: '.$url.'&done=1');
			exit;
		}
		else
		{
			buffer::str('<div class="erreur"><p><strong>'.__('Error(s)').' </strong></p></div>');
		}
	}

	if (!empty($_GET['done']))
		buffer::str('<div class="erreur"><p><strong>'.__('Saved').' </strong></p></div>');

	if (file_exists($file))
		$questions = parse_ini_file($file, true);

	if (empty($questions))
		$questions = array(array('', ''), array('', ''));

	buffer::str('<form method="post" action="">
	<p>'.__('This plugin functions as an easy antispam tool. You can enter questions and answers here. '.
		'One a of those will be randomly asked to the user when he wants to comment on an article. '.
		'If the answer is wrong, the user can\'t add a comment. Answers are case insensitive.').'</p>
	<fieldset>
		<legend>'.__('Fill-in those questions and answers').'</legend>
		<table id="questionRows"><tbody>');

	foreach ($questions as $k=>$q)
	{
		buffer::str('<tr><th>'.($k+1).'.</th><td><strong>'.__('Question :').'</strong></td><td>'.
			form::field('questions['.$k.'][0]',60,'', htmlspecialchars($q[0])) . '</td></tr>');
		buffer::str('<tr><th></th><td><strong>'.__('Answer :').'</strong></td><td>'.
			form::field('questions['.$k.'][1]',40,'', htmlspecialchars($q[1])) . '</td></tr>');
	}

	buffer::str('</tbody></table>
	</fieldset>
	<script type="text/javascript">
	function addQuestionRow()
	{
		var table = document.getElementById("questionRows").tBodies[0];
		var nb = Math.ceil(table.rows.length / 2) + 1;
		var row = table.rows[0].cloneNode(true);

		row.getElementsByTagName("th")[0].innerHTML = nb + ".";
		row.getElementsByTagName("input")[0].name = "questions["+nb+"][0]";
		row.getElementsByTagName("input")[0].value = "";

		table.appendChild(row);

		var row = table.rows[1].cloneNode(true);
		row.getElementsByTagName("input")[0].name = "questions["+nb+"][1]";
		row.getElementsByTagName("input")[0].value = "";
		table.appendChild(row);

	}
	</script>
	<p style="float: right;">
		<input class="submit" type="button" onclick="addQuestionRow();" value="'.__('Add a question/answer row').'" />
	</p>
	<p class="field">'.
	dcNonce::form().
	'<input class="submit" type="submit" name="save" value="'.__('save').'" /></p>

	</form>');
}

?>