<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of Pagination, a plugin for DotClear.
# Copyright (c) 2004-2007 Pep and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****
$pg_allowed_modes = array(
	'home',
	'cat',
	'year',
	'month',
	'day',
	'search'
	);

$pg_base_options = array(
	'nav_class',
	'modes',
	'pagesize',
	'groupsize'
	);

if (is_array($PAGINATION_OPTIONS)) {
	foreach ($PAGINATION_OPTIONS as $key => $value) {
		if (preg_match('/^(pgs|grs|ord)_([a-z]+)$/', $key, $matches)) {
			if (in_array($matches[2], $pg_allowed_modes)) {
				$opt_name = 'pg_'.$matches[1];
				switch ($matches[1]) {
					case 'ord' : {
						if (!empty($value)) {
							${$opt_name}[$matches[2]] = $value;
						}
						break;
					}
					default : {
						$nb = (integer)$value;
						if ($nb > 0) {
							${$opt_name}[$matches[2]] = $nb;
						}
						break;
					}
				}
			}
		} elseif (in_array($key, $pg_base_options)) {
			$opt_name = 'pg_'.$key;
			switch ($key) {
				case 'nav_class' : {
					$classname = trim(strtolower($value));
					if (!empty($classname) && class_exists($classname)) {
						$$opt_name = $classname;
					}
					break;
				}
				case 'pagesize' :
				case 'groupsize' : {
					$nb = (integer)$value;
					if ($nb > 0) {
						$$opt_name = $nb;
					}
					break;
				}
				case 'modes' : {
					$pg_modes = explode(';',$value);
					break;
				}
			}

		}
	}
}
?>