<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of Pagination, a plugin for DotClear.
# Copyright (c) 2004-2007 Pep and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****
$my_path = dirname(__FILE__);
require_once($my_path.'/inc/class.pagenavigator.php');
require_once($my_path.'/lib.utf8tools.php');

/**
 @class dcPagination

 */
class dcPagination {
	/**
	@function restoreMode

	Rend  la variable $mode sa valeur DotClear initiale.

	*/
	function restoreMode() {
		global $is_paginated;

		if (!empty($is_paginated)) {
			$GLOBALS['mode'] = $GLOBALS['dc_orig_mode'];
			unset($GLOBALS['dc_orig_mode']);
		}
	}

	/**
	 @function showNavigation

	 Affiche la barre de navigation au sein de la pagination.

	 @param	string	bloc		Chaine de formatage du bloc englobant
	 @param	string	current		Chaine de formatage pour la page courante
	 @param	string	page_link	Chaine de formatage pour un lien vers une page
	 @param	string	prev_link	Chaine de formatage pour le lien page prcdente
	 @param	string	next_link	Chaine de formatage pour le lien page suivante
	 @param	string	prev_group	Chaine de formatage pour le lien groupe prcdent
	 @param	string	next_group	Chaine de formatage pour le lien groupe suivant
	 @param	string	sep			Chaine de sparation des liens de la navigation

	 */
	function showNavigation()
	{
		global $page_nav;
		
		$args = func_get_args();
		if ($page_nav->nb_pages > 1) {
			print(
				utf8tools::utf8Encode(
					call_user_func_array(
						array($page_nav,'getNavigation'),
						$args
						)
					)
				);
		}
	}

	/**
	 @function showCleanNavigation

	 Affiche une barre de navigation allge, idale pour les longues
	 listes de billets. Les blogueurs prolixes devraient tre ravis.

	 ( Dites "Merci, Beubeu !" Merci Beubeu ;-) )

	 @param	string	prev	Chaine pour le nom du lien page prcdente
	 @param	string	current	Chaine de formatage pour les informations de page courante
	 @param	string	next	Chaine pour le nom du lien page suivante
	 @param string	bloc	Chaine de formatage du bloc XHTML englobant
	 @param	string	sep		Chaine de sparation entre les lments de navigation
	 */
	function showCleanNavigation()
	{
		global $page_nav;
		
		$args = func_get_args();
		if ($page_nav->nb_pages > 1) {
			print(
				utf8tools::utf8Encode(
					call_user_func_array(
						array($page_nav,'getCleanNavigation'),
						$args
						)
					)
				);
		}
	}

	/**
	 @function getInfos

	 Permet l'affichage des informations quant  la position et l'tat actuel
	 de la pagination.

	 Les informations disponibles sont :
	 	- la page courante (%1$d)
	 	- le nombre total de pages (%2$d)
	 	- le numro d'enregistrement dbutant le lot (%3$d)

	 @param	string	s	Chaine de formatage de la sortie
	 */
	function getInfos($s = '%1$d %2$d') {
		global $page_nav;
		print(utf8tools::utf8Encode(
			sprintf($s, $page_nav->page, $page_nav->nb_pages, $page_nav->idx)
			));
	}

	/**
	@function customCall

	Permet l'appel d'une mthode additionnelle d'un objet "pagenavigator" surcharg.

	@param	string	method_name	Chaine reprsentant le nom de la mthode  invoquer
	@param	mixed	method_args	Variable mixed contenant les ventuels arguments de la mthode
	*/
	function customCall() {
		global $page_nav;

		$args = func_get_args();
		if (!empty($args)) {
			$method_name = array_shift($args);

			if (method_exists($page_nav, $method_name)) {
				call_user_func_array(
					array($page_nav,$method_name),
					$args
					);
			}
		}
	}
}
?>