<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of Pagination, a plugin for DotClear.
# Copyright (c) 2004-2007 Pep and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****
include_once(dirname(__FILE__).'/lib.installer.php');

$my_name = 'pagination';
$url = 'tools.php?p='.$my_name;

$PLUGIN_HEAD =
	'<script type="text/javascript">'."\n".
	"//<![CDATA[\n".
	"$(function() {\n".
	"	$('#img_moreOptions').optionalToggle($('#moreOptions'),{\n".
	"		cookie: 'dc_pagination_options',\n".
	"		hide: true\n".
	"	});\n".
	"});\n".
	"\n//]]>\n".
	'</script>'
;

buffer::str('<h2>'.__('Pagination').'</h2>');

// Traitement des modifications de la configuration
if (isset($_POST['submit']))
{
 	$my_config = array();

 	// Activation de la pagination
 	$my_config['dc_pagination_active'] = !(empty($_POST['active']));

 	// Modes  intercepter
 	$intercepted_modes = array();
	foreach (array('home','cat','year','month','day','search') as $key) {
		if (!empty($_POST[$key])) {
			$intercepted_modes[$key] = true;
		}
	}
	$my_config['dc_pagination_modes'] = implode(';',array_keys($intercepted_modes));

	// Options avances (0.1.4+)
	// Nombre de billets par page
	$pg_pagesize  = (integer)$_POST['posts_per_page'];
	if ($pg_pagesize <= 0) {
		$pg_pagesize = dc_nb_post_per_page;
	}
	$my_config['dc_pagination_pagesize'] = $pg_pagesize;

	// Nombre de pages par groupe
	$pg_groupsize = (integer)$_POST['pages_per_group'];
	if ($pg_groupsize <= 0) {
		$pg_groupsize = 5;
	}
	$my_config['dc_pagination_groupsize'] = $pg_groupsize;

	// Activation du mode tendu
	$my_config['dc_pagination_external'] = isset($_POST['external']);

	// Ecriture de la nouvelle configuration
	if (installer::savePluginConfig($my_name,$my_config)) {
		$res = __('New configuration saved.');
	} else {
		$res = __('Unable to save configuration');
	}
}
// Vrification de l'installation et rcupration de la configuration
else
{
	if (($err = installer::checkPluginShareDir($my_name))) {
		buffer::str(
		'<div class="erreur"><p><strong>'.
		sprintf(__('Unavailable %s/ directory in share/. You may create it manually.'),$my_name).
		'</strong></p>'.
		'</div>'
		);
	}
	$my_config = installer::loadPluginConfig($my_name);
	if (!$my_config) {
		$my_config = array('dc_pagination_active' => 0, 'dc_pagination_modes' => '');
	}
	$intercepted_modes = array();
	if ($my_config['dc_pagination_modes'] != '') {
		foreach (explode(';',$my_config['dc_pagination_modes']) as $key) {
			$intercepted_modes[$key] = true;
		}
	}
}

// Affichage d'un message d'erreur ou d'tat si dfini.
if (!empty($res)) {
	buffer::str('<div class="erreur"><p>'.$res.'</p></div>');
}

// Affichage du formulaire de modification des paramtres de configuration
buffer::str(
	'<h3>'.__('Configuration').'</h3>'.
	'<form method="post" action="'.$url.'">'.
	'<fieldset>'.
	'<legend>'.__('Plugin activation').'</legend>'.
	'<p class="field">'.
	'<label class="float" for="active">'.__('Enable pagination').'&nbsp;'.helpLink('index&amp;plugin='.$my_name,'activation').'</label>'.
	form::checkbox('active', 1, !empty($my_config['dc_pagination_active'])?'checked':'','','active').
	'</p>'.
	'</fieldset>'.
	'<fieldset>'.
	'<legend>'.__('Mode(s) to intercept').'</legend>'.
	'<p class="field">'.
	'<label class="float" for="home">'.__('Homepage').'&nbsp;'.helpLink('index&amp;plugin='.$my_name,'home').'</label>'.
	form::checkbox('home', 1, !empty($intercepted_modes['home'])?'checked':'','','home').
	'</p>'.
	'<p class="field">'.
	'<label class="float" for="cat">'.__('Categories').'&nbsp;'.helpLink('index&amp;plugin='.$my_name,'cat').'</label>'.
	form::checkbox('cat', 1, !empty($intercepted_modes['cat'])?'checked':'','','cat').
	'</p>'.
	'<p class="field">'.
	'<label class="float" for="month">'.__('Archives').'&nbsp;'.helpLink('index&amp;plugin='.$my_name,'month').'</label>'.
	form::checkbox('month', 1, !empty($intercepted_modes['month'])?'checked':'','','month').
	'</p>'.
	'<p class="field">'.
	'<label class="float" for="day">'.__('Daily').'&nbsp;'.helpLink('index&amp;plugin='.$my_name,'day').'</label>'.
	form::checkbox('day', 1, !empty($intercepted_modes['day'])?'checked':'','','day').
	'</p>'.
	// Interception du mode recherche (0.2RC1+)
	'<p class="field">'.
	'<label class="float" for="search">'.__('Search').'&nbsp;'.helpLink('index&amp;plugin='.$my_name,'search').'</label>'.
	form::checkbox('search', 1, !empty($intercepted_modes['search'])?'checked':'','','search').
	'</p>'.
	'</fieldset>'
	);

// Options avances (0.1.4+)
buffer::str(
	'<h3 class="moreOptions">'.
	'<img src="images/plus.png" id="img_moreOptions" alt="" /> '.
	__('Advanced configuration').'</h3>'.

	'<div id="moreOptions" class="moreOptions">'.

	'<fieldset>'.
	'<legend style="background:transparent;">'.__('Pagination display options').'</legend>'.
	'<p class="field">'.
	'<label class="float" for="posts_per_page">'.__('Posts per page').'&nbsp;'.helpLink('index&amp;plugin='.$my_name,'posts_per_page').'</label>'.
	form::field('posts_per_page',5,5,!empty($my_config['dc_pagination_pagesize'])?$my_config['dc_pagination_pagesize']:dc_nb_post_per_page).
	'</p>'.

	'<p class="field">'.
	'<label class="float" for="pages_per_group">'.__('Pages per group').'&nbsp;'.helpLink('index&amp;plugin='.$my_name,'pages_per_group').'</label> '.
	form::field('pages_per_group',5,5,!empty($my_config['dc_pagination_groupsize'])?$my_config['dc_pagination_groupsize']:5).
	'</p>'.

	'</fieldset>'.

	// Permettre les options compltes externes (0.2RC1+)
	'<fieldset>'.
	'<legend style="background:transparent;">'.__('Full external options').'</legend>'.
	'<p class="field">'.
	'<label class="float" for="external">'.__('Allow external options').'&nbsp;'.helpLink('index&amp;plugin='.$my_name,'external').'</label>'.
	form::checkbox('external', 1, !empty($my_config['dc_pagination_external'])?'checked':'','','external').
	'</p>'.
	'</fieldset>'.

	'</div>'
	);

buffer::str(
	'<p>'.
	dcNonce::form().
	'<input class="submit" type="submit" name="submit" value="'.__('Save changes').'" /></p>'.
	'</form>'
	);

// Notes rapides pour une utilisation basique
/*
buffer::str(
	'<h3>'.__('Usage').'</h3>'.
	'<h4>'.__('Recommended method').'</h4>'.
	'<p>'.__('First, in the <strong>template.php</strong> of your theme, add the following line at the very top of the file').' :</p>'.
	'<pre>'.
	'&lt;?php if (!empty($is_paginated)) dcPagination::restoreMode(); ?&gt;'.
	'</pre>'.
	'<p>'.__('Then, in the <strong>list.php</strong> file of your theme, add the following line before and/or after the while loop').' :</p>'.
	'<pre>'.
	'&lt;?php if (!empty($is_paginated)) dcPagination::showNavigation(); ?&gt;'.
	'</pre>'.
	'<h4>'.__('Backward compatible method').'</h4>'.
	'<p>'.__('In the <strong>list.php</strong> file of your theme, add the following line before and/or after the while loop').' :</p>'.
	'<pre>'.
	'&lt;?php if ($mode == \'pagination\') dcPagination::showNavigation(); ?&gt;'.
	'</pre>'.
	'<h4>'.__('Advanced usage').'</h4>'.
	'<p>'.__('For a more advanced usage or more options, please check help.').'&nbsp;'.helpLink('guide&amp;plugin='.$my_name,'')
	);
*/
?>