<?php
/* ***** BEGIN LICENSE BLOCK *****
* This is related, a plugin for DotClear.
* Copyright (c) 2005 Benoit CLERC and contributors. All rights
* reserved.
*
* DotClear is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* DotClear is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with DotClear; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* ***** END LICENSE BLOCK *****
*/
if (!class_exists('utf8tools')) {
	class utf8tools {
		/**
		 @function seemsUtf8

		 Dtermine si la chaine est code en UTF-8.
		 Retourne TRUE si c'est le cas, FALSE sinon

		 Code trouv sur http://fr2.php.net/manual/fr/function.utf8-encode.php

		 @param	string	s	Chaine  vrifier

		 @return	boolean
		 */
		/*
		function seemsUtf8($s)
		{
			for ($i=0; $i<strlen($s); $i++) {
				if (ord($s[$i]) < 0x80) continue;
				elseif ((ord($s[$i]) & 0xE0) == 0xC0) $n=1;
				elseif ((ord($s[$i]) & 0xF0) == 0xE0) $n=2;
				elseif ((ord($s[$i]) & 0xF8) == 0xF0) $n=3;
				elseif ((ord($s[$i]) & 0xFC) == 0xF8) $n=4;
				elseif ((ord($s[$i]) & 0xFE) == 0xFC) $n=5;
				else return false;
				for ($j=0; $j<$n; $j++) {
					if ((++$i == strlen($s)) || ((ord($s[$i]) & 0xC0) != 0x80))
					return false;
				}
			}
			return true;
		}
		*/


		/**
		@function seemsUtf8

		Dtermine si la chaine est code en UTF-8.
		Retourne TRUE si c'est le cas, FALSE sinon

		Code trouv sur http://w3.org/International/questions/qa-forms-utf-8.html

		@param string s Chaine  vrifier

		@return boolean
		*/
		function seemsUtf8($s) {
			return preg_match('%^(?:
			[\x09\x0A\x0D\x20-\x7E]            # ASCII
			| [\xC2-\xDF][\x80-\xBF]            # non-overlong 2-byte
			|  \xE0[\xA0-\xBF][\x80-\xBF]        # excluding overlongs
			| [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
			|  \xED[\x80-\x9F][\x80-\xBF]        # excluding surrogates
			|  \xF0[\x90-\xBF][\x80-\xBF]{2}    # planes 1-3
			| [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
			|  \xF4[\x80-\x8F][\x80-\xBF]{2}    # plane 16
			)*$%xs', $s);
		}


		/**
		 @function utf8Encode

		 Encodage UTF-8 si ncessaire.

		 Cette fonction dtermine si une chaine doit tre encode en UTF-8 ou non.
		 La dcision est prise en fonction de l'encodage initial de la chaine
		 fournie et de l'encodage configur dans DotClear.

		 @param	string	s	Chaine  encoder

		 @return string
		 */
		function utf8Encode($s)
		{
			$utf = utf8tools::seemsUtf8($s);

			return dc_encoding == 'UTF-8' ? ($utf ? $s : utf8_encode($s)) : ($utf ? utf8_decode($s) : $s);
		}
	}
}
?>