<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of Pagination, a plugin for DotClear.
# Copyright (c) 2004-2007 Pep and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

// Lecture de la configuration. En cas d'absence de fichier .ini, on dsactive.
$cfg_file = DC_SHARE_DIR.'/pagination/pagination.ini';
$pg_active = false;

if (@file_exists($cfg_file))
{
	$pg_config = iniFile::read($cfg_file, true);
	$pg_active = $pg_config['dc_pagination_active'];
}

// On ne lance le traitement que si le plugin est activ.
if ($pg_active)
{
	// Suite et fin de la configuration
	$pg_nav_class = 'pagenavigator';
	$pg_modes     = explode(';',$pg_config['dc_pagination_modes']);
	$pg_pagesize  = (integer)$pg_config['dc_pagination_pagesize'];
	$pg_groupsize = (integer)$pg_config['dc_pagination_groupsize'];
	$pg_extopts   = (boolean)$pg_config['dc_pagination_external'];

	// "Let's go crazy !" ... no comment :-p
	// Nous avons maintenant droit  une splendide usine  gaz pour que
	// les utilisateurs puissent jouer comme des petits fous.
	$pg_pgs['home']=$pg_pgs['cat']=$pg_pgs['year']=$pg_pgs['month']=$pg_pgs['day']=$pg_pgs['search'] = $pg_pagesize;
	$pg_grs['home']=$pg_grs['cat']=$pg_grs['year']=$pg_grs['month']=$pg_grs['day']=$pg_grs['search'] = $pg_groupsize;
	$pg_ord['home']=$pg_ord['cat']=$pg_ord['year']=$pg_ord['month']=$pg_ord['day']=$pg_ord['search'] = 'post_dt DESC';

	// Gestion du mode tendu ct plugin
	if (!empty($pg_config['dc_pagination_extended']))
	{
		if (!empty($pg_config['dc_pagination_nav_class']) &&
			class_exists($pg_config['dc_pagination_nav_class']))
		{
			$pg_nav_class = $pg_config['dc_pagination_nav_class'];
		}
	}

	// Prise en charge des options fournies par des extensions tierces
	if ($pg_extopts && isset($PAGINATION_OPTIONS)) {
		include_once(dirname(__FILE__).'/extoptions.php');
	}

	$opt_exc_cats = $opt_only_cats = '';
	if (!empty($excluded_cats)) {
		$opt_exc_cats = $excluded_cats;
	}
	elseif (!empty($only_cats)) {
		$opt_only_cats = $only_cats;
	}
	
	$page_nav = new $pg_nav_class();
	if (!is_a($page_nav, 'pagenavigator')) {
		return;
	}

	// On vrifie s'il s'agit bien d'un mode intercept.
	if (in_array($mode,$pg_modes)) {

		//$current_query = $dc_args;

		// Vilaine soupe pour rcuprer le numro de page et recrer l'url
		// On porte une attention particulire au mode home, il peut y avoir le related
		// ou d'autres plugins qui attendent ...
		$pagination_current = 1;
		$pg_url = '';

		if ($mode == 'search') {
			if (!empty($_GET['page'])) {
				$pagination_current = max(1, (integer)$_GET['page']);
			}
		} elseif (!empty($dc_args)) {
			$args = explode('/',$dc_args);
			if ($mode == 'home' && (count($args) > 1)) return;
			if (preg_match('/^p(\d*)$/', $args[count($args) - 1], $matches)) {
				$pagination_current = (integer)$matches[1];
				array_pop($args);
				$pg_url = implode('/',$args);
			} else {
				if ($mode == 'home') {
					if (!empty($args[0]) && $args[0] == $dc_args) return;
				}
				$pagination_current = 1;
				$pg_url = $dc_args;
			}
		}

		// On bascule le mode DotClear en 'pagination' mais on conserve la version
		// originale dans une nouvelle variable globale $dc_orig_mode.
		$dc_orig_mode = $mode;
		$mode = 'pagination';
		$is_paginated = true;
		$p_options = array();
		$p_options['cat'] = $cat_id;
		$p_options['lang'] = $lang;

		// La cration de la variable $news  notre sauce, en fonction du mode DC
		// d'origine ...
		switch ($dc_orig_mode) {
			case 'home' : {
					$p_options['excluded_cats'] = $opt_exc_cats;
					$p_options['cat'] = $opt_only_cats;
			}
			case 'cat'  : {
				$page_nav->init(
					$blog->getPosts($p_options,true),
					$pg_url,
					$pg_pgs[$dc_orig_mode],
					$pg_grs[$dc_orig_mode]
					);

				$p_options['limit'] = $page_nav->getLimitString();
				$p_options['order'] = $pg_ord[$dc_orig_mode];
				$news = $blog->getPosts($p_options);

				break;
			}
			case 'year'  : // Mode 'year' dsactiv dans DC 1.2+, mais on ne sait jamais...
			case 'month' :
			case 'day'   : {
				$p_options['year'] = $year;
				$p_options['month'] = $month;
				$p_options['day'] = $day;

				$page_nav->init(
					$blog->getPosts($p_options,true),
					$pg_url,
					$pg_pgs[$dc_orig_mode],
					$pg_grs[$dc_orig_mode]
					);

				$p_options['limit'] = $page_nav->getLimitString();
				$p_options['order'] = $pg_ord[$dc_orig_mode];
				$news = $blog->getPosts($p_options);

				break;
			}
			case 'search' : {
				$p_options['search'] = $_GET['q'];
				
				$page_nav->init(
					$blog->getPosts($p_options,true),
					$pg_url,
					$pg_pgs[$dc_orig_mode],
					$pg_grs[$dc_orig_mode],
					true
					);

				$p_options['limit'] = $page_nav->getLimitString();
				$p_options['order'] = $pg_ord[$dc_orig_mode];
				$news = $blog->getPosts($p_options);

				break;
			}
			default: break;
		}

		// Le bon vieux message d'erreur si le recordset $news n'est pas
		// dfini ou vide.
		if (!isset($news) || $news->isEmpty()) {
			$err_msg = '<p>'.__('No entry.').'</p>';
		}
	}
}
?>