<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****


/* --------------------------------------------------------
                DO NOT EDIT THIS FILE
               NE PAS EDITER CE FICHIER
-------------------------------------------------------- */


if (!defined('DC_BASE_DIR'))
	define('DC_BASE_DIR', dirname(dirname(__FILE__)));

#Version de DotClear
if (file_exists(DC_BASE_DIR . '/VERSION')) {
	define('DC_VERSION',trim(implode('',file(DC_BASE_DIR . '/VERSION'))));
} else {
	define('DC_VERSION','?');
}

# Lancement des session si besoin
define('DC_SESSION_NAME','dc_xd');
if (defined('DC_START_SESSION') && !defined('DC_NO_SESSION')) {
	require DC_BASE_DIR . '/inc/session.php';
}

# Chargement du fichier ini
require_once DC_BASE_DIR . '/inc/classes/class.ini.file.php';
iniFile::read(DC_BASE_DIR . '/conf/dotclear.ini');

# dc_img_root
if (!defined('dc_img_root'))
{
	// Si on a dfinit dc_img_path
	if (defined('dc_img_path') && dc_img_path != '')
	{
		// Si dc_img_path commence par un slash, c'est un chemin absolu
		if (substr(dc_img_path, 0, 1) == '/')
		{
			define('dc_img_root', dc_img_path);
		}
		// Sinon c'est un chemin relatif  la racine du site (DOCUMENT_ROOT)
		// Ca craint a (DOCUMENT_ROOT est pas du tout fiable comme info) mais on fait avec
		else
		{
			define('dc_img_root', $_SERVER['DOCUMENT_ROOT'] . '/' . dc_img_path);
		}
	}
	// Sinon on prends le truc par dfaut
	else
	{
		// Si dc_img_url contient dc_app_url on essaye de dterminer un path  partir de la diffrence des deux
		// C'est *trs* bancal comme truc (on confonds ici URL et Path, a craint), mais on garde
		// pour la compatibilit avec DC 1.2.x  (c'est la config par dfaut)
		if (dc_app_url != '' && strpos(dc_img_url, dc_app_url) === true)
		{
			define('dc_img_root', DC_BASE_DIR . str_replace(dc_app_url, "", dc_img_url));
		}
		// Sinon on fait un truc aussi bancal : on suppose que dc_img_url contient le nom du rpertoire
		// des images et on l'extrait en le mettant  la base de dotclear
		else
		{
			define('dc_img_root', DC_BASE_DIR . '/' . basename(dc_img_url));
		}
	}
}

# Chargement du layout d'URL
if (dc_url_scan == 'path_info')
{
	if (!defined('dc_format_post_url')) { define('dc_format_post_url','%04d/%02d/%02d/%d-%s'); }
	if (!defined('dc_format_cat_url')) { define('dc_format_cat_url','%s'); }
	if (!defined('dc_format_archive_url')) { define('dc_format_archive_url','%s/%02d'); }
	if (!defined('dc_format_day_url')) { define('dc_format_day_url','%s/%02d/%02d'); }
}
elseif (dc_url_scan == 'query_string')
{
	if (!defined('dc_format_post_url')) { define('dc_format_post_url','?%04d/%02d/%02d/%d-%s'); }
	if (!defined('dc_format_cat_url')) { define('dc_format_cat_url','?%s'); }
	if (!defined('dc_format_archive_url')) { define('dc_format_archive_url','?%s/%02d'); }
	if (!defined('dc_format_day_url')) { define('dc_format_day_url','?%s/%02d/%02d'); }
}
else
{
	if (!defined('dc_format_post_url')) { define('dc_format_post_url','%04d/%02d/%02d/%d-%s'); }
	if (!defined('dc_format_cat_url')) { define('dc_format_cat_url','%s'); }
	if (!defined('dc_format_archive_url')) { define('dc_format_archive_url','%s/%02d'); }
	if (!defined('dc_format_day_url')) { define('dc_format_day_url','%s/%02d/%02d'); }
}

# Chargement des locales
if (!empty($_SESSION['sess_user_lang'])) {
	define('DC_LANG',$_SESSION['sess_user_lang']);
} else {
	define('DC_LANG',dc_default_lang);
}

require_once DC_BASE_DIR . '/inc/libs/lib.l10n.php';
l10n::init();

# On vrifier si le fichie UPDATE est modifiable
define('DC_UPDATE_FILE', DC_BASE_DIR . '/conf/UPDATE');

if (defined('DC_UPDATE_FILE') && is_writable(DC_UPDATE_FILE)) {
	define('DC_UPDATE_FILE_W',true);
}

# Rpertoire share
define('DC_SHARE_DIR', DC_BASE_DIR . '/share');
?>